Mirando Hacia Adelante
======================

Si has leído el capítulo "Comenzando con Yii" completo, has creado una aplicación completa en Yii. En el proceso, has aprendido cómo implementar algunas
características comúnmente necesitadas, tales como obtener datos del usuario a través de formularios HTML, traer datos desde la base de datos,
y mostrar datos utilizando paginación. También has aprendido a utilizar [Gii](https://github.com/yiisoft/yii2-gii/blob/master/docs/guide/README.md) para generar
código automáticamente. Utilizar Gii para la generación de código transforma la carga en el proceso de tu desarrollo Web en una tarea tan simple como solamente completar unos formularios. 

Esta sección resumirá los recursos disponibles de Yii que te ayudarán a ser más productivo al utilizar el framework.

* Documentación
    - [La Guía Definitiva](https://www.yiiframework.com/doc-2.0/guide-README.html):
      Como su nombre lo indica, la guía define precisamente cómo debería trabajar Yii y provee guías generales
      acerca de su utilización. Es el tutorial más importante de Yii, y el que deberías leer 
      antes de escribir cualquier código en Yii.
    - [La Referencia de Clases](https://www.yiiframework.com/doc-2.0/index.html):
      Esta especifica el uso de cada clase provista por Yii. Debería ser utilizada principalmente cuando estás escribiendo
      código y deseas entender el uso de una clase, método o propiedad en particular. El uso de la referencia de clases es mejor luego de un entendimiento contextual del framework.
    - [Los Artículos de la Wiki](https://www.yiiframework.com/wiki/?tag=yii2):
      Los artículos de la wiki son escritos por usuarios de Yii basados en sus propias experiencias. La mayoría de ellos están escritos
      como recetas de cocina, y muestran cómo resolver problemas particulares utilizando Yii. Si bien la calidad de estos
      puede no ser tan buena como la de la Guía Definitiva, son útiles ya que cubren un espectro muy amplio
      de temas y puede proveer a menudo soluciones listas para usar.
    - [Libros](https://www.yiiframework.com/books)
* [Extensiones](https://www.yiiframework.com/extensions/):
  Yii puede hacer alarde de una librería de miles de extensiones contribuidas por usuarios, que pueden fácilmente conectadas a tu aplicación, haciendo que el desarrollo de la misma sea todavía más fácil y rápido.
* Comunidad
    - Foro: <https://forum.yiiframework.com/>
    - Chat IRC: El canal #yii en la red Libera (<ircs://irc.libera.chat:6697/yii>)
    - Chat Gitter: <https://gitter.im/yiisoft/yii2>
    - GitHub: <https://github.com/yiisoft/yii2>
    - Facebook: <https://www.facebook.com/groups/yiitalk/>
    - Twitter: <https://twitter.com/yiiframework>
    - LinkedIn: <https://www.linkedin.com/groups/yii-framework-1483367>
    - Stackoverflow: <https://stackoverflow.com/questions/tagged/yii2>
