# Qué necesita saber

La curva de aprendizaje de Yii no es tan empinada como en otros _frameworks_ en PHP,
pero todavía hay algunas cosas que debería aprender antes de empezar con Yii.

## PHP

Yii es un _framework_ (base estructurada de desarrollo) en PHP, así que asegúrese de
[leer y comprender la referencia del lenguaje](https://www.php.net/manual/es/langref.php).
Al desarrollar con Yii deberá escribir código de manera orientada a objetos, así que
asegúrese de estar familiarizado con
[clases y objetos](https://www.php.net/manual/es/language.oop5.basic.php) así como con
[espacios de nombres](https://www.php.net/manual/es/language.namespaces.php).

## Programación orientada a objetos

Se requiere una comprensión básica de la programación orientada a objetos.  Si no está
familiarizado con ella, diríjase a alguno de los muchos tutoriales disponibles, como
[el de tuts+](https://code.tutsplus.com/tutorials/object-oriented-php-for-beginners--net-12762).

Observe que cuanto más complicada sea su aplicación, más conceptos avanzados de la
POO deberá aprender para gestionar con éxito esa complejidad.

## Línea de órdenes y composer

Yii usa profusamente el gestor de paquetes _de facto_ de PHP, [Composer](https://getcomposer.org/),
así que asegúrese de leer y comprender su [guía](https://getcomposer.org/doc/01-basic-usage.md).
Si no está familiarizado con el uso de la línea de órdenes, es hora de empezar a probarla.
Una vez que aprenda los fundamentos, nunca querrá trabajar sin ella.
