Що таке Yii?
============

Yii – це високопродуктивний компонентний PHP-фреймворк, призначений для швидкої розробки сучасних веб-додатків.
Слово Yii (вимовляється як `Йі` `[ji:]`) в китайській мові означає "простий та еволюційний".
Також Yii може розшифровуватись як акронім для **Yes It Is**!


Для яких завдань найбільше підходить Yii?
-----------------------------------------

Yii – це універсальний фреймворк і може бути задіяний у всіх типах веб-додатків, що використовують PHP. 
Завдяки його компонентній структурі і відмінній підтримці кешування, фреймворк особливо підходить для розробки 
таких великих проектів як портали, форуми, системи керування вмістом (CMS), інтернет-магазини або RESTful-додатки.


Порівняння Yii з іншими фреймворками
------------------------------------

Якщо ви вже знайомі з іншими фреймворками, вам напевно буде цікаво порівняти їх із Yii:

- Як і багато інших PHP-фреймворків, Yii втілює архітектурний шаблон MVC (Model-View-Controller) та
  сприяє організації коду відповідно до вимог шаблону.
- Yii дотримується філософії простого й елегантного коду. Yii ніколи не буде намагатись пере-ускладнювати дизайн
  тільки заради слідування будь-яким шаблонам проектування.
- Yii є full-stack фреймворком і включає в себе перевірені можливості, які добре себе зарекомендували:
  конструктори запитів та ActiveRecord для реляційних та NoSQL баз даних, підтримка REST API, 
  багаторівневе кешування та інші.
- Yii надзвичайно розширюваний. Ви можете налаштувати або замінити практично будь-яку частину основного коду.
  Завдяки надійній архітектурі розширень Yii, досить легко використовувати або розробляти поширюванні розширення.
- Висока швидкодія завжди є головною ціллю Yii.

Yii — не проект однієї людини. Він підтримується і розвивається [сильною командою](https://www.yiiframework.com/team/) і великою спільнотою розробників,
які їй допомагають. Команда розробників фреймворку Yii стежать за тенденціями веб-розробки і розвитком інших проектів.
Найбільш значимі можливості та кращі практики регулярно впроваджуються у фреймворк у вигляді простих й елегантних інтерфейсів.

Версії Yii
----------

На даний момент існує дві основні версії Yii: 1.1 та 2.0. Версія 1.1 є попереднім поколінням і знаходиться у стані підтримки.
Версія 2.0 - це повністю переписаний Yii, що використовує останні технології і протоколи, такі як Composer, PSR, простори імен,
трейти і багато іншого. 2.0 - поточне покоління фреймворку. На цій версії будуть зосереджені основні зусилля
кілька наступних років. Даний посібник призначений в основному для версії 2.0.


Вимоги до ПЗ і знань
--------------------

Yii 2.0 потребує PHP 7.3.0 та вище. Щоб дізнатися вимоги для окремих можливостей ви можете запустити скрипт перевірки вимог,
який поставляється із кожним релізом фреймворку.

Для розробки на Yii необхідне загальне розуміння ООП, оскільки фреймворк повністю слідує цій парадигмі.
Також слід вивчити такі сучасні можливості PHP як [простори імен](https://www.php.net/manual/en/language.namespaces.php)
і [трейти](https://www.php.net/manual/en/language.oop5.traits.php).
