# What do you need to know

The Yii learning curve is not as steep as other PHP frameworks but still there are some things you should learn before starting with Yii.

## PHP

Yii is a PHP framework so make sure you [read and understand language reference](https://www.php.net/manual/en/langref.php).
When developing with Yii you will be writing code in an object-oriented fashion, so make sure you are familiar with [Classes and Objects](https://www.php.net/manual/en/language.oop5.basic.php) as well as [namespaces](https://www.php.net/manual/en/language.namespaces.php).

## Object oriented programming

Basic understanding of object-oriented programming is required. If you're not familiar with it, check one of the many
tutorials available such as [the one from tuts+](https://code.tutsplus.com/tutorials/object-oriented-php-for-beginners--net-12762).

Note that the more complicated your application is the more advanced OOP concepts you should learn in order to successfully
manage that complexity.

## Command line and composer

Yii extensively uses de-facto standard PHP package manager, [Composer](https://getcomposer.org/) so make sure you read
and understand its [guide](https://getcomposer.org/doc/01-basic-usage.md). If you are not familiar with using command line it is time to start trying. Once you
learn the basics you'll never want to work without it.

