Report an Issue
===============

Please follow the guidelines below when creating an issue so that your issue can be more promptly resolved:

* Provide information including: the version of PHP and Yii, the type of operating system and Web server, browser type and version;
* Provide the **complete** error call stack if available. A screenshot to explain the issue is very welcome.
* Describe the steps for reproducing the issue. It would be even better if you could provide code to reproduce the issue.
* If possible you may even create a failing unit test and [send it as a pull request](git-workflow.md).

If the issue is related to one of the official extensions, please report it in the extension repositories issue tracker.
If you are unsure, [report it to the main repository](https://github.com/yiisoft/yii2/issues/new) (<https://github.com/yiisoft/yii2/issues>).

**Do not report an issue if**

* you are asking how to use some Yii feature. You should use [the forum](https://forum.yiiframework.com/index.php/forum/42-general-discussions-for-yii-20/) or [chat room](https://www.yiiframework.com/chat/) for this purpose.
* your issue is about security. Please [contact us directly](https://www.yiiframework.com/security/) to report security issues.

**Avoid duplicated issues**

Before you report an issue, please search through [existing issues](https://github.com/yiisoft/yii2/issues) to see if your issue is already reported or fixed to make sure you are not reporting a duplicated issue. Also make sure you have the latest version of Yii and see if the issue still exists.
